Subject: Re: [PATCH v4 4/9] libperf: Add libperf_evsel__mmap()

From: Jiri Olsa <[email-masked]>
Date: Thu, 5 Nov 2020 23:41:21 +0100

On Thu, Nov 05, 2020 at 10:19:24AM -0600, Rob Herring wrote:

SNIP

> > > >
> > > > that maps page for each event, then perf_evsel__read
> > > > could go through the fast code, no?
> > >
> > > No, because we're not self-monitoring (pid == 0 and cpu == -1). With
> > > the following change:
> > >
> > > diff --git a/tools/lib/perf/tests/test-evsel.c
> > > b/tools/lib/perf/tests/test-evsel.c
> > > index eeca8203d73d..1fca9c121f7c 100644
> > > --- a/tools/lib/perf/tests/test-evsel.c
> > > +++ b/tools/lib/perf/tests/test-evsel.c
> > > @@ -17,6 +17,7 @@ static int test_stat_cpu(void)
> > >  {
> > >         struct perf_cpu_map *cpus;
> > >         struct perf_evsel *evsel;
> > > +       struct perf_event_mmap_page *pc;
> > >         struct perf_event_attr attr = {
> > >                 .type   = PERF_TYPE_SOFTWARE,
> > >                 .config = PERF_COUNT_SW_CPU_CLOCK,
> > > @@ -32,6 +33,15 @@ static int test_stat_cpu(void)
> > >         err = perf_evsel__open(evsel, cpus, NULL);
> > >         __T("failed to open evsel", err == 0);
> > >
> > > +       pc = perf_evsel__mmap(evsel, 0);
> > > +       __T("failed to mmap evsel", pc);
> > > +
> > > +#if defined(__i386__) || defined(__x86_64__) || defined(__aarch64__)
> > > +       __T("userspace counter access not supported", pc->cap_user_rdpmc);
> > > +       __T("userspace counter access not enabled", pc->index);
> > > +       __T("userspace counter width not set", pc->pmc_width >= 32);
> > > +#endif
> >
> > I'll need to check, I'm surprised this would depend on the way
> > you open the event
> 
> Any more thoughts on this?

sry I got stuck with other stuff.. I tried your change
and pc->cap_user_rdpmc is 0 because the test creates
software event, which does not support that

when I change that to:

	.type   = PERF_TYPE_HARDWARE,
	.config = PERF_COUNT_HW_CPU_CYCLES,

I don't see any of those warning you added

jirka

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel